diff --git a/src/backend/nodes/nodeFuncs.c b/src/backend/nodes/nodeFuncs.c
index ede838cd40c..5b11184bd0b 100644
--- a/src/backend/nodes/nodeFuncs.c
+++ b/src/backend/nodes/nodeFuncs.c
@@ -1241,12 +1241,12 @@ exprSetCollation(Node *expr, Oid collation)
 		case T_SQLValueFunction:
 			Assert((((SQLValueFunction *) expr)->type == NAMEOID) ?
 				   (collation == C_COLLATION_OID) :
-				   (collation == InvalidOid));
+				   (!OidIsValid(collation)));
 			break;
 		case T_XmlExpr:
 			Assert((((XmlExpr *) expr)->op == IS_XMLSERIALIZE) ?
 				   (collation == DEFAULT_COLLATION_OID) :
-				   (collation == InvalidOid));
+				   (!OidIsValid(collation)));
 			break;
 		case T_JsonValueExpr:
 			exprSetCollation((Node *) ((JsonValueExpr *) expr)->formatted_expr,
@@ -1867,7 +1867,7 @@ fix_opfuncids_walker(Node *node, void *context)
 void
 set_opfuncid(OpExpr *opexpr)
 {
-	if (opexpr->opfuncid == InvalidOid)
+	if (!OidIsValid(opexpr->opfuncid))
 		opexpr->opfuncid = get_opcode(opexpr->opno);
 }
 
@@ -1878,7 +1878,7 @@ set_opfuncid(OpExpr *opexpr)
 void
 set_sa_opfuncid(ScalarArrayOpExpr *opexpr)
 {
-	if (opexpr->opfuncid == InvalidOid)
+	if (!OidIsValid(opexpr->opfuncid))
 		opexpr->opfuncid = get_opcode(opexpr->opno);
 }
 
diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index 8335cf5b5c5..6915c2be08a 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -6270,7 +6270,7 @@ set_rel_width(PlannerInfo *root, RelOptInfo *rel)
 			}
 
 			/* Try to get column width from statistics */
-			if (reloid != InvalidOid && var->varattno > 0)
+			if (OidIsValid(reloid) && var->varattno > 0)
 			{
 				item_width = get_attavgwidth(reloid, var->varattno);
 				if (item_width > 0)
@@ -6333,7 +6333,7 @@ set_rel_width(PlannerInfo *root, RelOptInfo *rel)
 	{
 		int64		wholerow_width = MAXALIGN(SizeofHeapTupleHeader);
 
-		if (reloid != InvalidOid)
+		if (OidIsValid(reloid))
 		{
 			/* Real relation, so estimate true tuple width */
 			wholerow_width += get_relation_data_width(reloid,
diff --git a/src/backend/optimizer/path/indxpath.c b/src/backend/optimizer/path/indxpath.c
index edc6d2ac1d3..62a6642222b 100644
--- a/src/backend/optimizer/path/indxpath.c
+++ b/src/backend/optimizer/path/indxpath.c
@@ -3258,7 +3258,7 @@ match_rowcompare_to_indexcol(PlannerInfo *root,
 	{
 		/* indexkey is on right, so commute the operator */
 		expr_op = get_commutator(expr_op);
-		if (expr_op == InvalidOid)
+		if (!OidIsValid(expr_op))
 			return NULL;
 		var_on_left = false;
 	}
@@ -3585,7 +3585,7 @@ expand_indexqual_rowcompare(PlannerInfo *root,
 		{
 			/* indexkey is on right, so commute the operator */
 			expr_op = get_commutator(expr_op);
-			if (expr_op == InvalidOid)
+			if (!OidIsValid(expr_op))
 				break;			/* operator is not usable */
 		}
 		if (bms_is_member(index->rel->relid, pull_varnos(root, constop)))
@@ -3903,7 +3903,7 @@ match_clause_to_ordering_op(IndexOptInfo *index,
 	{
 		/* Might match, but we need a commuted operator */
 		expr_op = get_commutator(expr_op);
-		if (expr_op == InvalidOid)
+		if (!OidIsValid(expr_op))
 			return NULL;
 		commuted = true;
 	}
diff --git a/src/backend/optimizer/path/joinpath.c b/src/backend/optimizer/path/joinpath.c
index ea5b6415186..0bddd63a613 100644
--- a/src/backend/optimizer/path/joinpath.c
+++ b/src/backend/optimizer/path/joinpath.c
@@ -2155,7 +2155,7 @@ hash_inner_and_outer(PlannerInfo *root,
 			continue;
 
 		if (!restrictinfo->can_join ||
-			restrictinfo->hashjoinoperator == InvalidOid)
+			!OidIsValid(restrictinfo->hashjoinoperator))
 			continue;			/* not hashjoinable */
 
 		/*
diff --git a/src/backend/optimizer/prep/prepqual.c b/src/backend/optimizer/prep/prepqual.c
index 008dce2478c..f8a60f429ee 100644
--- a/src/backend/optimizer/prep/prepqual.c
+++ b/src/backend/optimizer/prep/prepqual.c
@@ -95,7 +95,7 @@ negate_clause(Node *node)
 				OpExpr	   *opexpr = (OpExpr *) node;
 				Oid			negator = get_negator(opexpr->opno);
 
-				if (negator)
+				if (OidIsValid(negator))
 				{
 					OpExpr	   *newopexpr = makeNode(OpExpr);
 
@@ -120,7 +120,7 @@ negate_clause(Node *node)
 				ScalarArrayOpExpr *saopexpr = (ScalarArrayOpExpr *) node;
 				Oid			negator = get_negator(saopexpr->opno);
 
-				if (negator)
+				if (OidIsValid(negator))
 				{
 					ScalarArrayOpExpr *newopexpr = makeNode(ScalarArrayOpExpr);
 
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
index a01f781bca8..f244d53d709 100644
--- a/src/backend/optimizer/util/plancat.c
+++ b/src/backend/optimizer/util/plancat.c
@@ -822,7 +822,7 @@ infer_arbiter_indexes(PlannerInfo *root)
 	 * that already).
 	 */
 	if (onconflict->arbiterElems == NIL &&
-		onconflict->constraint == InvalidOid)
+		!OidIsValid(onconflict->constraint))
 		return NIL;
 
 	/*
@@ -869,11 +869,11 @@ infer_arbiter_indexes(PlannerInfo *root)
 	 * Lookup named constraint's index.  This is not immediately returned
 	 * because some additional sanity checks are required.
 	 */
-	if (onconflict->constraint != InvalidOid)
+	if (OidIsValid(onconflict->constraint))
 	{
 		indexOidFromConstraint = get_constraint_index(onconflict->constraint);
 
-		if (indexOidFromConstraint == InvalidOid)
+		if (!OidIsValid(indexOidFromConstraint))
 			ereport(ERROR,
 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
 					 errmsg("constraint in ON CONFLICT clause has no associated index")));
@@ -934,7 +934,7 @@ infer_arbiter_indexes(PlannerInfo *root)
 			table_close(relation, NoLock);
 			return results;
 		}
-		else if (indexOidFromConstraint != InvalidOid)
+		else if (OidIsValid(indexOidFromConstraint))
 		{
 			/* No point in further work for index in named constraint case */
 			goto next;
@@ -1003,8 +1003,8 @@ infer_arbiter_indexes(PlannerInfo *root)
 			 * Otherwise, check that element expression appears in cataloged
 			 * index definition.
 			 */
-			if (elem->infercollid != InvalidOid ||
-				elem->inferopclass != InvalidOid ||
+			if (OidIsValid(elem->infercollid) ||
+				OidIsValid(elem->inferopclass) ||
 				list_member(idxExprs, elem->expr))
 				continue;
 
@@ -1088,13 +1088,13 @@ infer_collation_opclass_match(InferenceElem *elem, Relation idxRel,
 	 * If inference specification element lacks collation/opclass, then no
 	 * need to check for exact match.
 	 */
-	if (elem->infercollid == InvalidOid && elem->inferopclass == InvalidOid)
+	if (!OidIsValid(elem->infercollid) && !OidIsValid(elem->inferopclass))
 		return true;
 
 	/*
 	 * Lookup opfamily and input type, for matching indexes
 	 */
-	if (elem->inferopclass)
+	if (OidIsValid(elem->inferopclass))
 	{
 		inferopfamily = get_opclass_family(elem->inferopclass);
 		inferopcinputtype = get_opclass_input_type(elem->inferopclass);
@@ -1110,14 +1110,14 @@ infer_collation_opclass_match(InferenceElem *elem, Relation idxRel,
 		if (attno != 0)
 			nplain++;
 
-		if (elem->inferopclass != InvalidOid &&
+		if (OidIsValid(elem->inferopclass) &&
 			(inferopfamily != opfamily || inferopcinputtype != opcinputtype))
 		{
 			/* Attribute needed to match opclass, but didn't */
 			continue;
 		}
 
-		if (elem->infercollid != InvalidOid &&
+		if (OidIsValid(elem->infercollid) &&
 			elem->infercollid != collation)
 		{
 			/* Attribute needed to match collation, but didn't */
diff --git a/src/backend/parser/parse_clause.c b/src/backend/parser/parse_clause.c
index ca26f6f61f2..abf44a9beb8 100644
--- a/src/backend/parser/parse_clause.c
+++ b/src/backend/parser/parse_clause.c
@@ -3709,7 +3709,7 @@ targetIsInSortList(TargetEntry *tle, Oid sortop, List *sortList)
 		SortGroupClause *scl = (SortGroupClause *) lfirst(l);
 
 		if (scl->tleSortGroupRef == ref &&
-			(sortop == InvalidOid ||
+			(!OidIsValid(sortop) ||
 			 sortop == scl->sortop ||
 			 sortop == get_commutator(scl->sortop)))
 			return true;
diff --git a/src/backend/parser/parse_coerce.c b/src/backend/parser/parse_coerce.c
index 78b1e366ad7..d112aaf4464 100644
--- a/src/backend/parser/parse_coerce.c
+++ b/src/backend/parser/parse_coerce.c
@@ -3242,8 +3242,8 @@ find_coercion_pathway(Oid targetTypeId, Oid sourceTypeId,
 			Oid			targetElem;
 			Oid			sourceElem;
 
-			if ((targetElem = get_element_type(targetTypeId)) != InvalidOid &&
-				(sourceElem = get_element_type(sourceTypeId)) != InvalidOid)
+			if (OidIsValid((targetElem = get_element_type(targetTypeId))) &&
+				OidIsValid((sourceElem = get_element_type(sourceTypeId))))
 			{
 				CoercionPathType elempathtype;
 				Oid			elemfuncid;
@@ -3383,7 +3383,7 @@ typeIsOfTypedTable(Oid reltypeId, Oid reloftypeId)
 	Oid			relid = typeOrDomainTypeRelid(reltypeId);
 	bool		result = false;
 
-	if (relid)
+	if (OidIsValid(relid))
 	{
 		HeapTuple	tp;
 		Form_pg_class reltup;
diff --git a/src/backend/parser/parse_expr.c b/src/backend/parser/parse_expr.c
index 32d6ae918ca..47b4ba2ccf2 100644
--- a/src/backend/parser/parse_expr.c
+++ b/src/backend/parser/parse_expr.c
@@ -1199,7 +1199,7 @@ transformAExprIn(ParseState *pstate, A_Expr *a)
 			array_type = get_array_type(scalar_type);
 		else
 			array_type = InvalidOid;
-		if (array_type != InvalidOid)
+		if (OidIsValid(array_type))
 		{
 			/*
 			 * OK: coerce all the right-hand non-Var inputs to the common type
@@ -2047,7 +2047,7 @@ transformArrayExpr(ParseState *pstate, A_ArrayExpr *a,
 									  element_type,
 									  typmod);
 			/* we certainly have an array here */
-			Assert(array_type == InvalidOid || array_type == exprType(newe));
+			Assert(!OidIsValid(array_type) || array_type == exprType(newe));
 			newa->multidims = true;
 		}
 		else
@@ -2752,7 +2752,7 @@ transformTypeCast(ParseState *pstate, TypeCast *tc)
 		expr = transformExprRecurse(pstate, arg);
 
 	inputType = exprType(expr);
-	if (inputType == InvalidOid)
+	if (!OidIsValid(inputType))
 		return expr;			/* do nothing if NULL input */
 
 	/*
diff --git a/src/backend/parser/parse_oper.c b/src/backend/parser/parse_oper.c
index 7bd7a336fd6..7daebbde586 100644
--- a/src/backend/parser/parse_oper.c
+++ b/src/backend/parser/parse_oper.c
@@ -266,12 +266,12 @@ binary_oper_exact(List *opname, Oid arg1, Oid arg2)
 	bool		was_unknown = false;
 
 	/* Unspecified type for one of the arguments? then use the other */
-	if ((arg1 == UNKNOWNOID) && (arg2 != InvalidOid))
+	if ((arg1 == UNKNOWNOID) && (OidIsValid(arg2)))
 	{
 		arg1 = arg2;
 		was_unknown = true;
 	}
-	else if ((arg2 == UNKNOWNOID) && (arg1 != InvalidOid))
+	else if ((arg2 == UNKNOWNOID) && (OidIsValid(arg1)))
 	{
 		arg2 = arg1;
 		was_unknown = true;
@@ -417,9 +417,9 @@ oper(ParseState *pstate, List *opname, Oid ltypeId, Oid rtypeId,
 			 */
 			Oid			inputOids[2];
 
-			if (rtypeId == InvalidOid)
+			if (!OidIsValid(rtypeId))
 				rtypeId = ltypeId;
-			else if (ltypeId == InvalidOid)
+			else if (!OidIsValid(ltypeId))
 				ltypeId = rtypeId;
 			inputOids[0] = ltypeId;
 			inputOids[1] = rtypeId;
@@ -641,7 +641,7 @@ op_error(ParseState *pstate, List *op,
 				(errcode(ERRCODE_UNDEFINED_FUNCTION),
 				 errmsg("operator does not exist: %s",
 						op_signature_string(op, arg1, arg2)),
-				 oper_lookup_failure_details(fgc_flags, (!arg1 || !arg2)),
+				 oper_lookup_failure_details(fgc_flags, (!OidIsValid(arg1) || !OidIsValid(arg2))),
 				 parser_errposition(pstate, location)));
 }
 
diff --git a/src/backend/parser/parse_target.c b/src/backend/parser/parse_target.c
index 905c975d83b..281e01de843 100644
--- a/src/backend/parser/parse_target.c
+++ b/src/backend/parser/parse_target.c
@@ -775,7 +775,7 @@ transformAssignmentIndirection(ParseState *pstate,
 			baseTypeId = getBaseTypeAndTypmod(targetTypeId, &baseTypeMod);
 
 			typrelid = typeidTypeRelid(baseTypeId);
-			if (!typrelid)
+			if (!OidIsValid(typrelid))
 				ereport(ERROR,
 						(errcode(ERRCODE_DATATYPE_MISMATCH),
 						 errmsg("cannot assign to field \"%s\" of column \"%s\" because its type %s is not a composite type",
diff --git a/src/backend/parser/parse_type.c b/src/backend/parser/parse_type.c
index 7713bdc6af0..c0ddd714db0 100644
--- a/src/backend/parser/parse_type.c
+++ b/src/backend/parser/parse_type.c
@@ -357,7 +357,7 @@ typenameTypeMod(ParseState *pstate, const TypeName *typeName, Type typ)
 
 	typmodin = ((Form_pg_type) GETSTRUCT(typ))->typmodin;
 
-	if (typmodin == InvalidOid)
+	if (!OidIsValid(typmodin))
 		ereport(ERROR,
 				(errcode(ERRCODE_SYNTAX_ERROR),
 				 errmsg("type modifier is not allowed for type \"%s\"",
diff --git a/src/backend/parser/parse_utilcmd.c b/src/backend/parser/parse_utilcmd.c
index e96b38a59d5..36894527bd4 100644
--- a/src/backend/parser/parse_utilcmd.c
+++ b/src/backend/parser/parse_utilcmd.c
@@ -525,7 +525,7 @@ generateSerialExtraStmts(CreateStmtContext *cxt, ColumnDef *column,
 	 * clause, the "redundant options" error will point to their occurrence,
 	 * not our synthetic one.
 	 */
-	if (seqtypid)
+	if (OidIsValid(seqtypid))
 		seqstmt->options = lcons(makeDefElem("as",
 											 (Node *) makeTypeNameFromOid(seqtypid, -1),
 											 -1),
@@ -3746,7 +3746,7 @@ transformAlterTableStmt(Oid relid, AlterTableStmt *stmt,
 
 					seq_relid = getIdentitySequence(rel, attnum, true);
 
-					if (seq_relid)
+					if (OidIsValid(seq_relid))
 					{
 						AlterSeqStmt *seqstmt;
 
diff --git a/src/backend/replication/libpqwalreceiver/libpqwalreceiver.c b/src/backend/replication/libpqwalreceiver/libpqwalreceiver.c
index 239641bfbb6..40f4a4878df 100644
--- a/src/backend/replication/libpqwalreceiver/libpqwalreceiver.c
+++ b/src/backend/replication/libpqwalreceiver/libpqwalreceiver.c
@@ -1105,7 +1105,7 @@ libpqrcv_exec(WalReceiverConn *conn, const char *query,
 	WalRcvExecResult *walres = palloc0(sizeof(WalRcvExecResult));
 	char	   *diag_sqlstate;
 
-	if (MyDatabaseId == InvalidOid)
+	if (!OidIsValid(MyDatabaseId))
 		ereport(ERROR,
 				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 				 errmsg("the query interface requires a database connection")));
diff --git a/src/backend/replication/logical/decode.c b/src/backend/replication/logical/decode.c
index cc03f0706e9..fd3906b2d18 100644
--- a/src/backend/replication/logical/decode.c
+++ b/src/backend/replication/logical/decode.c
@@ -1306,7 +1306,7 @@ DecodeTXNNeedSkip(LogicalDecodingContext *ctx, XLogRecordBuffer *buf,
 				  Oid txn_dbid, RepOriginId origin_id)
 {
 	if (SnapBuildXactNeedsSkip(ctx->snapshot_builder, buf->origptr) ||
-		(txn_dbid != InvalidOid && txn_dbid != ctx->slot->data.database) ||
+		(OidIsValid(txn_dbid) && txn_dbid != ctx->slot->data.database) ||
 		FilterByOrigin(ctx, origin_id))
 		return true;
 
diff --git a/src/backend/replication/logical/logical.c b/src/backend/replication/logical/logical.c
index 866f92cf799..b304f2f8906 100644
--- a/src/backend/replication/logical/logical.c
+++ b/src/backend/replication/logical/logical.c
@@ -122,7 +122,7 @@ CheckLogicalDecodingRequirements(void)
 				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 				 errmsg("logical decoding requires \"wal_level\" >= \"logical\"")));
 
-	if (MyDatabaseId == InvalidOid)
+	if (!OidIsValid(MyDatabaseId))
 		ereport(ERROR,
 				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 				 errmsg("logical decoding requires a database connection")));
diff --git a/src/backend/replication/logical/relation.c b/src/backend/replication/logical/relation.c
index 745fd3bab64..9059f7faf73 100644
--- a/src/backend/replication/logical/relation.c
+++ b/src/backend/replication/logical/relation.c
@@ -69,7 +69,7 @@ logicalrep_relmap_invalidate_cb(Datum arg, Oid reloid)
 	if (LogicalRepRelMap == NULL)
 		return;
 
-	if (reloid != InvalidOid)
+	if (OidIsValid(reloid))
 	{
 		HASH_SEQ_STATUS status;
 
@@ -540,7 +540,7 @@ logicalrep_partmap_invalidate_cb(Datum arg, Oid reloid)
 	if (LogicalRepPartMap == NULL)
 		return;
 
-	if (reloid != InvalidOid)
+	if (OidIsValid(reloid))
 	{
 		HASH_SEQ_STATUS status;
 
diff --git a/src/backend/replication/logical/reorderbuffer.c b/src/backend/replication/logical/reorderbuffer.c
index eb6a84554b7..c1c13f43918 100644
--- a/src/backend/replication/logical/reorderbuffer.c
+++ b/src/backend/replication/logical/reorderbuffer.c
@@ -2342,11 +2342,11 @@ ReorderBufferProcessTXN(ReorderBuffer *rb, ReorderBufferTXN *txn,
 					 * whether the table should be logically logged without
 					 * mapping the relfilenumber to the oid.
 					 */
-					if (reloid == InvalidOid &&
+					if (!OidIsValid(reloid) &&
 						change->data.tp.newtuple == NULL &&
 						change->data.tp.oldtuple == NULL)
 						goto change_done;
-					else if (reloid == InvalidOid)
+					else if (!OidIsValid(reloid))
 						elog(ERROR, "could not map filenumber \"%s\" to relation OID",
 							 relpathperm(change->data.tp.rlocator,
 										 MAIN_FORKNUM).str);
diff --git a/src/backend/replication/pgoutput/pgoutput.c b/src/backend/replication/pgoutput/pgoutput.c
index 942e1abdb58..7063dfdab21 100644
--- a/src/backend/replication/pgoutput/pgoutput.c
+++ b/src/backend/replication/pgoutput/pgoutput.c
@@ -2231,7 +2231,7 @@ get_rel_sync_entry(PGOutputData *data, Relation relation)
 															   ancestors,
 															   &level);
 
-					if (ancestor != InvalidOid)
+					if (OidIsValid(ancestor))
 					{
 						ancestor_published = true;
 						if (pub->pubviaroot)
diff --git a/src/backend/replication/slot.c b/src/backend/replication/slot.c
index 1ec1e997b27..6d8dccb89f1 100644
--- a/src/backend/replication/slot.c
+++ b/src/backend/replication/slot.c
@@ -1763,7 +1763,7 @@ DetermineSlotInvalidationCause(uint32 possible_causes, ReplicationSlot *s,
 	{
 		/* invalid DB oid signals a shared relation */
 		if (SlotIsLogical(s) &&
-			(dboid == InvalidOid || dboid == s->data.database))
+			(!OidIsValid(dboid) || dboid == s->data.database))
 		{
 			TransactionId effective_xmin = s->effective_xmin;
 			TransactionId catalog_effective_xmin = s->effective_catalog_xmin;
@@ -2637,7 +2637,7 @@ RestoreSlotFromDisk(const char *name)
 	 * NB: Changing the requirements here also requires adapting
 	 * CheckSlotRequirements() and CheckLogicalDecodingRequirements().
 	 */
-	if (cp.slotdata.database != InvalidOid)
+	if (OidIsValid(cp.slotdata.database))
 	{
 		if (wal_level < WAL_LEVEL_LOGICAL)
 			ereport(FATAL,
diff --git a/src/backend/replication/slotfuncs.c b/src/backend/replication/slotfuncs.c
index 0478fc9c977..cf25bcfcd22 100644
--- a/src/backend/replication/slotfuncs.c
+++ b/src/backend/replication/slotfuncs.c
@@ -275,17 +275,17 @@ pg_get_replication_slots(PG_FUNCTION_ARGS)
 		i = 0;
 		values[i++] = NameGetDatum(&slot_contents.data.name);
 
-		if (slot_contents.data.database == InvalidOid)
+		if (!OidIsValid(slot_contents.data.database))
 			nulls[i++] = true;
 		else
 			values[i++] = NameGetDatum(&slot_contents.data.plugin);
 
-		if (slot_contents.data.database == InvalidOid)
+		if (!OidIsValid(slot_contents.data.database))
 			values[i++] = CStringGetTextDatum("physical");
 		else
 			values[i++] = CStringGetTextDatum("logical");
 
-		if (slot_contents.data.database == InvalidOid)
+		if (!OidIsValid(slot_contents.data.database))
 			nulls[i++] = true;
 		else
 			values[i++] = ObjectIdGetDatum(slot_contents.data.database);
diff --git a/src/backend/replication/walsender.c b/src/backend/replication/walsender.c
index fc8f8559073..8945290e685 100644
--- a/src/backend/replication/walsender.c
+++ b/src/backend/replication/walsender.c
@@ -324,7 +324,7 @@ InitWalSender(void)
 	 * databases.  This allows physical replication clients to send hot
 	 * standby feedback that will delay vacuum cleanup in all databases.
 	 */
-	if (MyDatabaseId == InvalidOid)
+	if (!OidIsValid(MyDatabaseId))
 	{
 		Assert(MyProc->xmin == InvalidTransactionId);
 		LWLockAcquire(ProcArrayLock, LW_EXCLUSIVE);
@@ -428,7 +428,7 @@ IdentifySystem(void)
 
 	snprintf(xloc, sizeof(xloc), "%X/%08X", LSN_FORMAT_ARGS(logptr));
 
-	if (MyDatabaseId != InvalidOid)
+	if (OidIsValid(MyDatabaseId))
 	{
 		MemoryContext cur = CurrentMemoryContext;
 
@@ -2062,7 +2062,7 @@ exec_replication_command(const char *cmd_string)
 		MemoryContextReset(cmd_context);
 
 		/* XXX this is a pretty random place to make this check */
-		if (MyDatabaseId == InvalidOid)
+		if (!OidIsValid(MyDatabaseId))
 			ereport(ERROR,
 					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 					 errmsg("cannot execute SQL commands in WAL sender for physical replication")));
@@ -3067,7 +3067,7 @@ InitWalSenderSlot(void)
 			 * StartLogicalReplication() and CREATE_REPLICATION_SLOT but it
 			 * seems better to set it on one place.
 			 */
-			if (MyDatabaseId == InvalidOid)
+			if (!OidIsValid(MyDatabaseId))
 				walsnd->kind = REPLICATION_KIND_PHYSICAL;
 			else
 				walsnd->kind = REPLICATION_KIND_LOGICAL;
diff --git a/src/backend/rewrite/rewriteHandler.c b/src/backend/rewrite/rewriteHandler.c
index adc9e7600e1..80e9077d28f 100644
--- a/src/backend/rewrite/rewriteHandler.c
+++ b/src/backend/rewrite/rewriteHandler.c
@@ -4518,7 +4518,7 @@ build_generation_expression(Relation rel, int attrno)
 	 * expression.
 	 */
 	attcollid = att_tup->attcollation;
-	if (attcollid && attcollid != exprCollation(defexpr))
+	if (OidIsValid(attcollid) && attcollid != exprCollation(defexpr))
 	{
 		CollateExpr *ce = makeNode(CollateExpr);
 
diff --git a/src/backend/statistics/dependencies.c b/src/backend/statistics/dependencies.c
index 6f63b4f3ffb..4b7234fef4e 100644
--- a/src/backend/statistics/dependencies.c
+++ b/src/backend/statistics/dependencies.c
@@ -261,7 +261,7 @@ dependency_degree(StatsBuildData *data, int k, AttrNumber *dependency)
 		TypeCacheEntry *type;
 
 		type = lookup_type_cache(colstat->attrtypid, TYPECACHE_LT_OPR);
-		if (type->lt_opr == InvalidOid) /* shouldn't happen */
+		if (!OidIsValid(type->lt_opr))	/* shouldn't happen */
 			elog(ERROR, "cache lookup failed for ordering operator for type %u",
 				 colstat->attrtypid);
 
diff --git a/src/backend/statistics/mcv.c b/src/backend/statistics/mcv.c
index f59fb821543..e531f74796c 100644
--- a/src/backend/statistics/mcv.c
+++ b/src/backend/statistics/mcv.c
@@ -359,7 +359,7 @@ build_mss(StatsBuildData *data)
 		TypeCacheEntry *type;
 
 		type = lookup_type_cache(colstat->attrtypid, TYPECACHE_LT_OPR);
-		if (type->lt_opr == InvalidOid) /* shouldn't happen */
+		if (!OidIsValid(type->lt_opr))	/* shouldn't happen */
 			elog(ERROR, "cache lookup failed for ordering operator for type %u",
 				 colstat->attrtypid);
 
diff --git a/src/backend/statistics/mvdistinct.c b/src/backend/statistics/mvdistinct.c
index fe452f53ae4..dc2b801b30e 100644
--- a/src/backend/statistics/mvdistinct.c
+++ b/src/backend/statistics/mvdistinct.c
@@ -387,7 +387,7 @@ ndistinct_for_combination(double totalrows, StatsBuildData *data,
 		collid = colstat->attrcollid;
 
 		type = lookup_type_cache(typid, TYPECACHE_LT_OPR);
-		if (type->lt_opr == InvalidOid) /* shouldn't happen */
+		if (!OidIsValid(type->lt_opr))	/* shouldn't happen */
 			elog(ERROR, "cache lookup failed for ordering operator for type %u",
 				 typid);
 
diff --git a/src/backend/storage/buffer/bufmgr.c b/src/backend/storage/buffer/bufmgr.c
index 327ddb7adc8..a7355ed57a7 100644
--- a/src/backend/storage/buffer/bufmgr.c
+++ b/src/backend/storage/buffer/bufmgr.c
@@ -3449,7 +3449,7 @@ BufferSync(int flags)
 		 * Grow array of per-tablespace status structs, every time a new
 		 * tablespace is found.
 		 */
-		if (last_tsid == InvalidOid || last_tsid != cur_tsid)
+		if (!OidIsValid(last_tsid) || last_tsid != cur_tsid)
 		{
 			Size		sz;
 
diff --git a/src/backend/storage/file/fd.c b/src/backend/storage/file/fd.c
index e9eaaf9c829..cca2be29899 100644
--- a/src/backend/storage/file/fd.c
+++ b/src/backend/storage/file/fd.c
@@ -1758,7 +1758,7 @@ OpenTemporaryFile(bool interXact)
 	 * here, but just in case it isn't, fall back to pg_default tablespace.
 	 */
 	if (file <= 0)
-		file = OpenTemporaryFileInTablespace(MyDatabaseTableSpace ?
+		file = OpenTemporaryFileInTablespace(OidIsValid(MyDatabaseTableSpace) ?
 											 MyDatabaseTableSpace :
 											 DEFAULTTABLESPACE_OID,
 											 true);
@@ -1784,7 +1784,7 @@ TempTablespacePath(char *path, Oid tablespace)
 	 *
 	 * If someone tries to specify pg_global, use pg_default instead.
 	 */
-	if (tablespace == InvalidOid ||
+	if (!OidIsValid(tablespace) ||
 		tablespace == DEFAULTTABLESPACE_OID ||
 		tablespace == GLOBALTABLESPACE_OID)
 		snprintf(path, MAXPGPATH, "base/%s", PG_TEMP_FILES_DIR);
diff --git a/src/backend/storage/ipc/procarray.c b/src/backend/storage/ipc/procarray.c
index 200f72c6e25..7d81ac78264 100644
--- a/src/backend/storage/ipc/procarray.c
+++ b/src/backend/storage/ipc/procarray.c
@@ -1803,7 +1803,7 @@ ComputeXidHorizons(ComputeXidHorizonsResult *h)
 		 * machinery.
 		 */
 		if (proc->databaseId == MyDatabaseId ||
-			MyDatabaseId == InvalidOid ||
+			!OidIsValid(MyDatabaseId) ||
 			(statusFlags & PROC_AFFECTS_ALL_HORIZONS) ||
 			in_recovery)
 		{
@@ -3631,7 +3631,7 @@ CancelDBBackends(Oid databaseid, ProcSignalReason sigmode, bool conflictPending)
 		int			pgprocno = arrayP->pgprocnos[index];
 		PGPROC	   *proc = &allProcs[pgprocno];
 
-		if (databaseid == InvalidOid || proc->databaseId == databaseid)
+		if (!OidIsValid(databaseid) || proc->databaseId == databaseid)
 		{
 			VirtualTransactionId procvxid;
 			pid_t		pid;
diff --git a/src/backend/storage/lmgr/lock.c b/src/backend/storage/lmgr/lock.c
index 4cc7f645c31..de5829fc368 100644
--- a/src/backend/storage/lmgr/lock.c
+++ b/src/backend/storage/lmgr/lock.c
@@ -268,7 +268,7 @@ int			FastPathLockGroupsPerBackend = 0;
 	((locktag)->locktag_lockmethodid == DEFAULT_LOCKMETHOD && \
 	(locktag)->locktag_type == LOCKTAG_RELATION && \
 	(locktag)->locktag_field1 == MyDatabaseId && \
-	MyDatabaseId != InvalidOid && \
+	OidIsValid(MyDatabaseId) && \
 	(mode) < ShareUpdateExclusiveLock)
 #define ConflictsWithRelationFastPath(locktag, mode) \
 	((locktag)->locktag_lockmethodid == DEFAULT_LOCKMETHOD && \
diff --git a/src/backend/storage/lmgr/predicate.c b/src/backend/storage/lmgr/predicate.c
index bb807d8c9cd..c983f7fce52 100644
--- a/src/backend/storage/lmgr/predicate.c
+++ b/src/backend/storage/lmgr/predicate.c
@@ -2971,7 +2971,7 @@ DropAllPredicateLocksFromTable(Relation relation, bool transfer)
 		isIndex = true;
 		heapId = relation->rd_index->indrelid;
 	}
-	Assert(heapId != InvalidOid);
+	Assert(OidIsValid(heapId));
 	Assert(transfer || !isIndex);	/* index OID only makes sense with
 									 * transfer */
 
diff --git a/src/backend/tcop/postgres.c b/src/backend/tcop/postgres.c
index 7dd75a490aa..19e00b1d259 100644
--- a/src/backend/tcop/postgres.c
+++ b/src/backend/tcop/postgres.c
@@ -733,7 +733,7 @@ pg_analyze_and_rewrite_varparams(RawStmt *parsetree,
 	{
 		Oid			ptype = (*paramTypes)[i];
 
-		if (ptype == InvalidOid || ptype == UNKNOWNOID)
+		if (!OidIsValid(ptype) || ptype == UNKNOWNOID)
 			ereport(ERROR,
 					(errcode(ERRCODE_INDETERMINATE_DATATYPE),
 					 errmsg("could not determine data type of parameter $%d",
diff --git a/src/backend/tsearch/ts_parse.c b/src/backend/tsearch/ts_parse.c
index cba421892bf..540c3f70703 100644
--- a/src/backend/tsearch/ts_parse.c
+++ b/src/backend/tsearch/ts_parse.c
@@ -177,7 +177,7 @@ LexizeExec(LexizeData *ld, ParsedLex **correspondLexem)
 	TSDictionaryCacheEntry *dict;
 	TSLexeme   *res;
 
-	if (ld->curDictId == InvalidOid)
+	if (!OidIsValid(ld->curDictId))
 	{
 		/*
 		 * usual mode: dictionary wants only one word, but we should keep in
diff --git a/src/backend/utils/activity/pgstat.c b/src/backend/utils/activity/pgstat.c
index 7ef06150df7..b16ba5aebaa 100644
--- a/src/backend/utils/activity/pgstat.c
+++ b/src/backend/utils/activity/pgstat.c
@@ -1156,7 +1156,7 @@ pgstat_build_snapshot(void)
 		 * relations).
 		 */
 		if (p->key.dboid != MyDatabaseId &&
-			p->key.dboid != InvalidOid &&
+			OidIsValid(p->key.dboid) &&
 			!kind_info->accessed_across_databases)
 			continue;
 
diff --git a/src/backend/utils/adt/array_selfuncs.c b/src/backend/utils/adt/array_selfuncs.c
index 4dab35b0057..fe72f25a20d 100644
--- a/src/backend/utils/adt/array_selfuncs.c
+++ b/src/backend/utils/adt/array_selfuncs.c
@@ -296,7 +296,7 @@ arraycontsel(PG_FUNCTION_ARGS)
 	 * we'd rather just return a default estimate.)
 	 */
 	element_typeid = get_base_element_type(((Const *) other)->consttype);
-	if (element_typeid != InvalidOid &&
+	if (OidIsValid(element_typeid) &&
 		element_typeid == get_base_element_type(vardata.vartype))
 	{
 		selec = calc_arraycontsel(&vardata, ((Const *) other)->constvalue,
diff --git a/src/backend/utils/adt/array_userfuncs.c b/src/backend/utils/adt/array_userfuncs.c
index 8eb342e3382..0f655af6e0f 100644
--- a/src/backend/utils/adt/array_userfuncs.c
+++ b/src/backend/utils/adt/array_userfuncs.c
@@ -559,7 +559,7 @@ array_agg_transfn(PG_FUNCTION_ARGS)
 	ArrayBuildState *state;
 	Datum		elem;
 
-	if (arg1_typeid == InvalidOid)
+	if (!OidIsValid(arg1_typeid))
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 				 errmsg("could not determine input data type")));
@@ -936,7 +936,7 @@ array_agg_array_transfn(PG_FUNCTION_ARGS)
 	MemoryContext aggcontext;
 	ArrayBuildStateArr *state;
 
-	if (arg1_typeid == InvalidOid)
+	if (!OidIsValid(arg1_typeid))
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 				 errmsg("could not determine input data type")));
diff --git a/src/backend/utils/adt/enum.c b/src/backend/utils/adt/enum.c
index fcc6981632b..4c2a456c12a 100644
--- a/src/backend/utils/adt/enum.c
+++ b/src/backend/utils/adt/enum.c
@@ -445,7 +445,7 @@ enum_first(PG_FUNCTION_ARGS)
 	 * examined at all; in particular it might be NULL.
 	 */
 	enumtypoid = get_fn_expr_argtype(fcinfo->flinfo, 0);
-	if (enumtypoid == InvalidOid)
+	if (!OidIsValid(enumtypoid))
 		ereport(ERROR,
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 				 errmsg("could not determine actual enum type")));
@@ -474,7 +474,7 @@ enum_last(PG_FUNCTION_ARGS)
 	 * examined at all; in particular it might be NULL.
 	 */
 	enumtypoid = get_fn_expr_argtype(fcinfo->flinfo, 0);
-	if (enumtypoid == InvalidOid)
+	if (!OidIsValid(enumtypoid))
 		ereport(ERROR,
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 				 errmsg("could not determine actual enum type")));
@@ -514,7 +514,7 @@ enum_range_bounds(PG_FUNCTION_ARGS)
 	 * both are of the same type.
 	 */
 	enumtypoid = get_fn_expr_argtype(fcinfo->flinfo, 0);
-	if (enumtypoid == InvalidOid)
+	if (!OidIsValid(enumtypoid))
 		ereport(ERROR,
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 				 errmsg("could not determine actual enum type")));
@@ -534,7 +534,7 @@ enum_range_all(PG_FUNCTION_ARGS)
 	 * examined at all; in particular it might be NULL.
 	 */
 	enumtypoid = get_fn_expr_argtype(fcinfo->flinfo, 0);
-	if (enumtypoid == InvalidOid)
+	if (!OidIsValid(enumtypoid))
 		ereport(ERROR,
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 				 errmsg("could not determine actual enum type")));
diff --git a/src/backend/utils/adt/format_type.c b/src/backend/utils/adt/format_type.c
index 9948c26e76c..4b7f7cdae3a 100644
--- a/src/backend/utils/adt/format_type.c
+++ b/src/backend/utils/adt/format_type.c
@@ -118,7 +118,7 @@ format_type_extended(Oid type_oid, int32 typemod, bits16 flags)
 	char	   *buf;
 	bool		with_typemod;
 
-	if (type_oid == InvalidOid)
+	if (!OidIsValid(type_oid))
 	{
 		if ((flags & FORMAT_TYPE_INVALID_AS_NULL) != 0)
 			return NULL;
@@ -375,7 +375,7 @@ printTypmod(const char *typname, int32 typmod, Oid typmodout)
 	/* Shouldn't be called if typmod is -1 */
 	Assert(typmod >= 0);
 
-	if (typmodout == InvalidOid)
+	if (!OidIsValid(typmodout))
 	{
 		/* Default behavior: just print the integer typmod with parens */
 		res = psprintf("%s(%d)", typname, (int) typmod);
